Une vulnerabilite dans la bibliotheque Google Play Core n’est toujours gui?re corrigee dans les applications Google Play

decembre 2020 avec Check Point

D’innombrables applications Android toujours vulnerables a votre bug majeur, mettant en danger des centaines de millions d’utilisateurs. Beaucoup de applications sur le Play Store de Google seront bien vulnerables a votre bug connu, CVE-2020-8913, qui permet aux acteurs de la menace d’injecter du code malveillant dans des applications vulnerables, afin d’acceder a toutes les memes ressources de l’application d’hebergement. Les acteurs de la menace ont la possibilite de utiliser les applications vulnerables pour usurper des precisions sensibles d’autres applications sur le aussi appareil, en volant les informations privees des utilisateurs, telles que nos details de connexion, les mots de passe, les details financiers et le courrier.

• La faille de securite trouve le origine dans la bibliotheque Play Core de Google, tres utilisee, qui permet a toutes les developpeurs d’integrer des mises a jour et de nouveaux modules de fonctionnalites a leurs applications Android • Google a corrige la faille en avril 2020, mais les developpeurs eux-memes doivent installer la nouvelle bibliotheque Play Core De sorte i  faire disparaitre totalement la menace • Les chercheurs de Check Point ont selectionne au hasard un certain nombre d’applications de premier plan Afin de confirmer l’existence une vulnerabilite CVE-2020-8913. Vulnerabilite confirmee dans Grindr, Bumble, OKCupid, Cisco Teams, Moovit, Yango Pro, Edge, Xrecorder, PowerDirector • Plusieurs chercheurs de Check Point demontrent l’exploitation d’la vulnerabilite de l’application Google Chrome d’Android

Vue d’ensemble : Une nouvelle vulnerabilite dans la bibliotheque Google Play Core fut publiee fin aout, qui permet l’execution locale de code (Local-Code-Execution, LCE) au contexte de toute application qui utilise la version vulnerable de la bibliotheque Google Play Core. Dans ce document, nous analysons l’impact et l’ampleur de cette vulnerabilite du avis d’la securite.

Contexte : Qu’est-ce que J’ai bibliotheque Google Play Core ? Tire une documentation de developpement Android de Google :

La bibliotheque Play Core Library est l’interface d’execution de votre application avec Google Play Store. Voici quelques-unes des actions que vous pouvez effectuer avec Google Play Core : • Telecharger des ressources linguistiques supplementaires • Gerer J’ai fourniture de modules de fonctionnalites • Gerer Notre fourniture de packs de ressources • Declencher des mises a jour au sein d’ l’application • Demander des avis depuis l’application

Ainsi, la bibliotheque Google Play Core reste une passerelle permettant d’interagir au milieu des services Google Play depuis l’application elle-meme, a commencer avec le chargement de code dynamique (comme le telechargement de niveaux supplementaires en cas de besoin uniquement), la fourniture de ressources localisees bien particuliers et l’interaction au milieu des mecanismes d’avis de Google Play.

De nombreuses applications populaires utilisent une telle bibliotheque, surtout : • Google Chrome • Facebook • Instagram • WhatsApp • SnapChat • Booking • Edge

Facebook et Instagram constituent a eux seuls 5 milliards et 1 milliard de telechargements respectivement a votre jour depuis Google Play Store. Imaginez le nombre d’appareils ayant ete touches avec cette vulnerabilite.

Qu’est-ce que CVE-2020-8913 ?

OverSecured a deja presente des aspects techniques de votre vulnerabilite. Pour une analyse technique plus approfondie, veuillez vous referer a son blog. Un bref apercu : Dans Notre sandbox de chaque application, Il est 2 dossiers : 1 pour nos fichiers « verifies » recus de Google Play, et un autre Afin de des fichiers « non verifies ». Les fichiers telecharges avec des services Google Play vont au dossier verifie, tandis que les fichiers telecharges d’autres sources paraissent envoyes dans le dossier non verifie. Lorsqu’un fichier est ecrit dans le dossier verifie, il interagit avec la bibliotheque Google Play Core qui le charge et l’execute.

Une intention exportee est une autre fonctionnalite qui permet a d’autres sources de pousser des fichiers dans la sandbox de l’application. Il y a cependant deux limitations : le fichier est pousse dans le dossier non verifie, ainsi, il n’est nullement automatiquement traite par la bibliotheque. J’ai vulnerabilite reside dans la combinaison des deux fonctionnalites mentionnees ci-dessus, et utilise egalement la traversee de fichiers, un concept aussi vieux qu’Internet lui-meme. Lorsqu’une source tierce pousse un fichier dans une autre application, elle devra fournir un chemin d’acces afin que le fichier puisse etre ecrit. Lorsqu’un pirate utilise la traversee de fichiers (../verified_splits/mon_code_malveillant.apk), le code malveillant est ecrit dans le dossier verifie, ainsi, est automatiquement charge au sein d’ l’application vulnerable et execute dans le contexte.

Google a corrige cette vulnerabilite le 6 avril 2020.

Impact et ampleur : Lorsque nous combinons des applications populaires qui utilisent la bibliotheque Play Core de Google et J’ai vulnerabilite d’execution locale de code, nous pouvons bien voir les dangers. Lorsqu’une application malveillante exploite votre vulnerabilite, elle peut executer du code dans des applications populaires et beneficier du meme acces que l’application vulnerable.

Les possibilites ne sont limitees que via notre creativite. Voici quelques exemples : • Injection de code dans des applications bancaires pour s’emparer des identifiants, ainsi, en meme temps libre beneficier des autorisations sur les SMS pour voler nos codes d’authentification a 2 facteurs (2FA). • Injection de code dans des applications d’entreprise pour avoir acci?s a toutes les ressources de l’entreprise. • Injection de code dans des applications de reseaux sociaux pour espionner la victime, et choisir l’acces a la geolocalisation Afin de suivre l’appareil. • Injection de code dans des applications de messagerie instantanee pour capturer tous les messages, et eventuellement envoyer des messages au nom d’la victime.

Comme Notre vulnerabilite fut corrigee en avril, pourquoi s’inquieter maintenant ? La reponse reste que les developpeurs doivent pousser le correctif au sein d’ leurs applications. Contrairement a toutes les vulnerabilites cote serveur, qui peuvent etre entierement corrigees une fois que le correctif est applique via le serveur, pour les vulnerabilites cote client, chaque developpeur devra utiliser Notre derniere version en bibliotheque et l’inserer dans son application.

Le facteur humain etant l’un des plus difficiles a surmonter en matiere de securite, nous avons decide de determiner quelles applications ont corrige la vulnerabilite et lesquelles seront i  nouveau vulnerables, afin d’avoir une meilleure comprehension globale de l’ampleur une vulnerabilite. Depuis la publication de une telle vulnerabilite, nous avons commence a surveiller les applications vulnerables.

I  l’occasion du mois de septembre 2020, 13 % des applications Google Play analysees par SandBlast Mobile utilisaient votre bibliotheque, ainsi, 8 % de ces applications comprenaient une version vulnerable.

Nous avons egalement compare des versions de septembre aux versions actuelles sur Google Play De sorte i  voir quelles applications etaient encore concernees. A notre grande surprise, nous avons decouvert une grande variete d’applications : • Social – Viber • Voyage – Booking • Entreprises – Cisco Teams • Cartes et navigation – Yango Pro (Taximetre), Moovit • Rencontres – Grindr, OKCupid, Bumble • Navigateurs – Edge • Utilitaires – Xrecorder, PowerDirector